# norootforbuild

%define _with_gst	0
%define _with_sdl	1
%define wx_version	2.8

Name:			wxWidgets
Version:		2.8.8.1
Release:		4.5
Group:			System/Libraries
Summary:		C++ framework for cross-platform development
License:		wxWidgets
URL:			http://wxwidgets.org/
# Source from http://www.wxpython.org/
Source0:        http://downloads.sourceforge.net/wxpython/wxPython-src-%{version}.tar.bz2
Source1:		%{name}-2.8.8-HTML.tar.bz2
Source2:		README.unicode
Source3:		wxWidgets-rpmlintrc
Patch:			%{name}-2.7.0-no-double-wxyield.diff
BuildRoot:		%{_tmppath}/%{name}-%{version}-build
BuildRequires:	expat
BuildRequires:	gcc-c++
BuildRequires:	gtk2-devel
BuildRequires:	libjpeg-devel
BuildRequires:	libmspack-devel
BuildRequires:	libtiff-devel
BuildRequires:	gnome-vfs2-devel
BuildRequires:	libgnomeprintui-devel
BuildRequires:	mDNSResponder-lib
BuildRequires:	python-devel
BuildRequires:	unixODBC-devel
BuildRequires:	unzip

%if "%{_with_gst}" == "1"
%if %suse_version >= 1030
BuildRequires:	gstreamer-0_10-devel
BuildRequires:	gstreamer-0_10-plugins-base-devel
Requires:		gstreamer-0_10
Requires:		gstreamer-0_10-plugins-base
%else
BuildRequires:	gstreamer010-devel
BuildRequires:	gstreamer010-plugins-base-devel
Requires:		gstreamer010
Requires:		gstreamer010-plugins-base
%endif
%endif

%if "%{_with_sdl}" == "1"
BuildRequires:	SDL-devel
Requires:		SDL
%endif

%if %suse_version >= 1030
Provides:		wxGTK
Obsoletes:		wxGTK
%endif

%description
wxWidgets is a free C++ library for cross-platform GUI development.

With wxWidgets, you can create applications for different GUIs
(GTK+, Motif, MS Windows, MacOS X, Windows CE, GPE) from the same
source code.

This package contains the thread- and unicode enabled libraries.

%package devel
Summary:	Include files and libraries for wxWidgets development
Group:		Development/Libraries/C and C++
Requires:	%{name} = %{version}
Requires:	%{name}-compat = %{version}
Requires:	%{name}-gl = %{version}
Requires:	%{name}-gl-compat = %{version}
Requires:	gnome-vfs2-devel
%if "%{_with_gst}" == "1"
%if %suse_version >= 1030
Requires:	gstreamer-0_10-devel
Requires:	gstreamer-0_10-plugins-base-devel
%else
Requires:	gstreamer010-devel
Requires:	gstreamer010-plugins-base-devel
%endif
%endif
Requires:	gtk2-devel
Requires:	libgnomeprintui-devel
Requires:	libpng-devel
Requires:	libjpeg-devel
Requires:	libmspack-devel
Requires:	libtiff-devel
%if "%{_with_sdl}" == "1"
Requires:	SDL-devel
%endif
Requires:	unixODBC-devel
%if %suse_version >= 1030
Provides:	wxGTK-devel
Obsoletes:	wxGTK-devel
%endif

%description devel
Development package for wxWidgets.

%package compat
Summary:	Compatibility Package for wxWidgets
Group:		System/Libraries
Requires:	%{name} = %{version}
%if %suse_version >= 1030
Provides:	wxGTK-compat
Obsoletes:	wxGTK-compat
%endif

%description compat
wxWidgets is a free C++ library for cross-platform GUI development.

With wxWidgets, you can create applications for different GUIs
(GTK+, Motif, MS Windows, MacOS X, Windows CE, GPE) from the same
source code.

This package contains a library compiled without Unicode support,
which is needed for some improperly written applications.

%package docs
Summary:	HTML documentations for wxWidgets
Group:		Documentation/HTML
Requires:	%{name} = %{version}

%description docs
wxWidgets is a free C++ library for cross-platform GUI development.

With wxWidgets, you can create applications for different GUIs
(GTK+, Motif, MS Windows, MacOS X, Windows CE, GPE) from the same
source code.

This package contains the html documentation.

%package gl
Summary:	OpenGL add-on for wxWidgets
Group:		System/Libraries
Requires:	%{name} = %{version}
%if %suse_version >= 1030
Provides:	wxGTK-gl
Obsoletes:	wxGTK-gl
%endif

%description gl
OpenGL add-on library for wxGTK, the GTK+ port of the wxWidgets
library.

%package gl-compat
Summary:	OpenGL add-on for wxWidgets
Group:		System/Libraries
Requires:	%{name} = %{version}
#Requires:	%{name}-compat = %{version}

%description gl-compat
OpenGL add-on library for wxGTK, the GTK+ port of the wxWidgets
library compiled without Unicode support.

%if %suse_version >= 1030
%package -n python-wxGTK
Summary:	Cross Platform GUI Toolkit for Python Using wxGTK
Group:		Development/Libraries/Python
Url:		http://www.wxpython.org/
%{py_requires}
Requires:	wxWidgets
Provides:	wxPython

%description -n python-wxGTK
wxPython is a GUI toolkit for Python that is a wrapper around the
wxWidgets C++ GUI library.  wxPython provides a large variety of
window types and controls, all implemented with a native look and
feel (and native runtime speed) on the platforms it is supported
on.

Additional documentation is available in package python-wxGTK-doc
and demos and examples are in package python-wxGTK-examples.

Authors: Robin Dunn <robin@alldunn.com>
%endif

%debug_package

%prep
%setup -q -n wxPython-src-%{version} -a1
%patch -p1

# the wxWidgets-docs are repackaged as tar.bz2
#unzip -q -o %{SOURCE1}

%__install -m 644 %{SOURCE2} .

# fix typo in this source
%__sed -i -e 's|m_gnome_vfs_lib->.Detach();|m_gnome_vfs_lib->Detach();|g' \
	src/gtk/gnome/gvfs.cpp

%build
######################
# non-unicode version:
%__install -dm 755 build-ansi
pushd build-ansi
	../configure \
		--prefix=%{_prefix} \
		--datadir=%{_datadir} \
		--libdir='${prefix}/%{_lib}' \
		--enable-rpath='${prefix}/%{_lib}' \
		--disable-backtrace \
%if 0
		--disable-catch_segvs \
%endif
		--disable-debug \
		--disable-dialupman \
		--disable-gpe \
		--disable-profile \
		--enable-arcstream \
%ifnarch x86_64
		--enable-dataviewctrl \
%endif
		--enable-graphics_ctx \
		--enable-icocur \
%if "%{_with_gst}" == "1"
		--enable-mediactrl \
%endif
%if %suse_version <= 1020
		--enable-monolithic \
%endif
		--enable-optimise \
		--enable-shared \
		--enable-tabdialog \
		--enable-threads \
%if "%{_with_sdl}" == "1"
		--with-sdl \
%endif
		--with-gnomevfs \
		--with-libmspack \
		--with-odbc \
		--enable-burnt_name \
		--enable-sound \
		--with-gnomeprint \
		--enable-iff \
		--enable-geometry \
		--enable-soname \
		--enable-gtk2 \
		--enable-controls \
		--enable-calendar \
		--enable-std_iostreams \
		--with-opengl

%if %suse_version >= 1030
	%__make %{?jobs:-j%{jobs}}
%else
	%__make
%endif
	%__make %{?jobs:-j%{jobs}} -C contrib
popd

######################
# unicode version:
%__install -dm 755 build-unicode
pushd build-unicode
	../configure \
		--prefix=%{_prefix} \
		--datadir=%{_datadir} \
		--libdir='${prefix}/%{_lib}' \
		--enable-rpath='${prefix}/%{_lib}' \
		--disable-backtrace \
		--disable-catch_segvs \
		--disable-debug \
		--disable-dialupman \
		--disable-gpe \
		--disable-profile \
		--enable-arcstream \
%ifnarch x86_64
		--enable-dataviewctrl \
%endif
		--enable-graphics_ctx \
		--enable-icocur \
%if "%{_with_gst}" == "1"
		--enable-mediactrl \
%endif
%if %suse_version <= 1020
		--enable-monolithic \
%endif
		--enable-optimise \
		--enable-shared \
		--enable-tabdialog \
		--enable-threads \
		--enable-unicode \
%if "%{_with_sdl}" == "1"
		--with-sdl \
%endif
		--with-gnomevfs \
		--with-libmspack \
		--enable-burnt_name \
		--enable-sound \
		--with-gnomeprint \
		--enable-iff \
		--enable-geometry \
		--enable-soname \
		--enable-gtk2 \
		--enable-controls \
		--enable-calendar \
		--enable-std_iostreams \
		--with-opengl

%if %suse_version >= 1030
	%__make %{?jobs:-j%{jobs}}
%else
	%__make
%endif
	%__make %{?jobs:-j%{jobs}} -C contrib
popd

######################
# non-unicode, static version:
%__install -dm 755 build-ansi-static
pushd build-ansi-static
	../configure \
		--prefix=%{_prefix} \
		--datadir=%{_datadir} \
		--libdir='${prefix}/%{_lib}' \
		--enable-rpath='${prefix}/%{_lib}' \
		--disable-backtrace \
		--disable-catch_segvs \
		--disable-debug \
		--disable-dialupman \
		--disable-gpe \
		--disable-profile \
		--enable-arcstream \
%ifnarch x86_64
		--enable-dataviewctrl \
%endif
		--enable-graphics_ctx \
		--enable-icocur \
%if "%{_with_gst}" == "1"
		--enable-mediactrl \
%endif
%if %suse_version <= 1020
		--enable-monolithic \
%endif
		--enable-optimise \
		--disable-shared \
		--enable-tabdialog \
		--enable-threads \
%if "%{_with_sdl}" == "1"
		--with-sdl \
%endif
		--with-gnomevfs \
		--with-libmspack \
		--with-odbc \
		--enable-burnt_name \
		--enable-sound \
		--with-gnomeprint \
		--enable-iff \
		--enable-geometry \
		--enable-soname \
		--enable-gtk2 \
		--enable-controls \
		--enable-calendar \
		--enable-std_iostreams \
		--with-opengl

%if %suse_version >= 1030
	%__make %{?jobs:-j%{jobs}}
%else
	%__make
%endif
	%__make %{?jobs:-j%{jobs}} -C contrib
popd

######################
# unicode, static version:
%__install -dm 755 build-unicode-static
pushd build-unicode-static
	../configure \
		--prefix=%{_prefix} \
		--datadir=%{_datadir} \
		--libdir='${prefix}/%{_lib}' \
		--enable-rpath='${prefix}/%{_lib}' \
		--disable-backtrace \
		--disable-catch_segvs \
		--disable-debug \
		--disable-dialupman \
		--disable-gpe \
		--disable-profile \
		--enable-arcstream \
%ifnarch x86_64
		--enable-dataviewctrl \
%endif
		--enable-graphics_ctx \
		--enable-icocur \
%if "%{_with_gst}" == "1"
		--enable-mediactrl \
%endif
%if %suse_version <= 1020
		--enable-monolithic \
%endif
		--enable-optimise \
		--disable-shared \
		--enable-tabdialog \
		--enable-threads \
		--enable-unicode \
%if "%{_with_sdl}" == "1"
		--with-sdl \
%endif
		--with-gnomevfs \
		--with-libmspack \
		--enable-burnt_name \
		--enable-sound \
		--with-gnomeprint \
		--enable-iff \
		--enable-geometry \
		--enable-soname \
		--enable-gtk2 \
		--enable-controls \
		--enable-calendar \
		--enable-std_iostreams \
		--with-opengl

%if %suse_version >= 1030
	%__make %{?jobs:-j%{jobs}}
%else
	%__make
%endif
	%__make %{?jobs:-j%{jobs}} -C contrib
popd

%__make -C locale allmo

%install
######################
# non-unicode, static version:
pushd build-ansi-static
	%makeinstall
	pushd contrib
		%makeinstall
	popd
popd

######################
# non-unicode version:
pushd build-ansi
	%makeinstall
	pushd contrib
		%makeinstall
	popd
popd

######################
# unicode, static version:
pushd build-unicode-static
	%makeinstall
	pushd contrib
		%makeinstall
	popd
popd

######################
# unicode version:
pushd build-unicode
	%makeinstall
	pushd contrib
		%makeinstall
	popd
popd

%if %suse_version <= 1020
	# rename/delete some files to avoid problems with wxGTK(-devel)
	%__mv %{buildroot}%{_bindir}/wx-config \
		%{buildroot}%{_bindir}/wx-config-2.8
	%__mv %{buildroot}%{_datadir}/aclocal/wxwin.m4 \
		%{buildroot}%{_datadir}/aclocal/wxwin-2.8.m4
	%__rm %{buildroot}%{_bindir}/wxrc
%endif

%if %suse_version >= 1030
######################
# wxPython
export CFLAGS="$RPM_OPT_FLAGS -I%{buildroot}%{_libdir}/wx/include/gtk2-unicode-release-2.8"
export CXXFLAGS="$CFLAGS"
export LDFLAGS=-L%{buildroot}%{_libdir}
pushd wxPython
	python setup.py \
		WX_CONFIG="%{buildroot}%{_libdir}/wx/config/gtk2-unicode-release-2.8 --prefix=%{buildroot}%{_prefix}" \
		EP_ADD_OPTS=1 \
		NO_SCRIPTS=1 \
		WXPORT=gtk2 \
		UNICODE=1 \
		build \
		install \
		--prefix=%{_prefix} \
		--root=%{buildroot} \
		--record-rpm=INSTALLED_FILES

	build_options=%{py_sitedir}/wx-2.8-gtk2-unicode/wx/build/build_options.py
	%__sed -i 's/^WX_CONFIG=.*/WX_CONFIG="wx-config --unicode"/' %{buildroot}$build_options
	python -c "import py_compile; py_compile.compile('%{buildroot}$build_options', None, '$build_options', True);"
popd
%endif

%find_lang wxstd

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%post compat -p /sbin/ldconfig
%postun compat -p /sbin/ldconfig

%post gl -p /sbin/ldconfig
%postun gl -p /sbin/ldconfig

%post gl-compat -p /sbin/ldconfig
%postun gl-compat -p /sbin/ldconfig

%clean
[ -d %{buildroot} -a "%{buildroot}" != "" ] && %__rm -rf %{buildroot}

%files -f wxstd.lang
%defattr(-,root,root)
%doc docs/*.txt
%exclude %{_libdir}/libwx_gtk2u_gl-*
%if %suse_version >= 1030
%{_libdir}/libwx_baseu[-_]*.so.*
%endif
%{_libdir}/libwx_gtk2u[-_]*.so.*
%{_datadir}/locale/*/LC_MESSAGES/wxmsw.mo

%files compat
%defattr(-, root, root)
%exclude %{_libdir}/libwx_gtk2_gl-*
%exclude %{_libdir}/libwx_gtk2u[-_]*
%if %suse_version >= 1030
%exclude %{_libdir}/libwx_baseu[-_]*
%{_libdir}/libwx_base*.so.*
%endif
%{_libdir}/libwx_gtk2*.so.*

%files gl
%defattr(-,root,root)
%{_libdir}/libwx_gtk2u_gl-*.so.*

%files gl-compat
%defattr(-,root,root)
%{_libdir}/libwx_gtk2_gl-*.so.*

%files devel
%defattr(-,root,root)
%doc README.unicode
%doc docs/html/*
%{_bindir}/*
%if %suse_version >= 1030
%exclude %{_includedir}/wx-%{wx_version}/wx/wxPython
%endif
%dir %{_includedir}/wx-%{wx_version}
%{_includedir}/wx-%{wx_version}/*
%if %suse_version >= 1030
%{_libdir}/libwx_base*.a
%{_libdir}/libwx_base*.so
%endif
%{_libdir}/libwx_gtk2*.a
%{_libdir}/libwx_gtk2*.so
%{_libdir}/libwxregexu-*.a
%if 0%{?suse_version} >= 1110
%{_libdir}/libwxexpat-2.8.a
%endif
%dir %{_libdir}/wx
%{_libdir}/wx/*
%{_datadir}/aclocal/*
%dir %{_datadir}/bakefile
%dir %{_datadir}/bakefile/presets
%{_datadir}/bakefile/presets/*.bkl

%files docs
%defattr(-, root, root)
%doc docs/mshtml/wx

%if %suse_version >= 1030
%files -n python-wxGTK 
%defattr(-, root, root)
%doc wxPython/docs/*.txt
%doc wxPython/docs/*.html
%doc wxPython/docs/screenshots
%doc wxPython/licence
%dir %{_includedir}/wx-%{wx_version}/wx
%{_includedir}/wx-%{wx_version}/wx/wxPython
%{py_sitedir}/*
%endif

%changelog
* Sat May 24 2008 Carsten Schoene <cs@linux-administrator.com>
- import for SLE_10 build

